#!/usr/bin/perl
umask 77;

$default_mysql_server = "localhost";

print "This tool will attempt to configure MySQL for use with The Ultimate POCSAG decoder.\n\n";
print "Default values are given in brackets. If the default is acceptable, just press enter.\n\n";
print "MySQL server address [$default_mysql_server]: ";
chomp($mysql_server = <>);

if (length($mysql_server) == 0)
{
  $mysql_server = $default_mysql_server;
}

$default_mysql_port = "3306";

print "MySQL server port [$default_mysql_port]: ";
chomp($mysql_server_port = <>);

if (length($mysql_server_port) == 0)
{
  $mysql_server_port = $default_mysql_port;
}

$default_mysql_admin = "root";

print "MySQL administration account name [$default_mysql_admin]: ";
chomp($mysql_admin = <>);

if (length($mysql_admin) == 0)
{
  $mysql_admin = $default_mysql_admin;
}

print "MySQL administration account password: ";
chomp($mysql_admin_pw = <>);

$default_mysql_db_name = "pocsag";

print "Desired MySQL database name [$default_mysql_db_name]: ";

chomp($mysql_db_name = <>);

if (length($mysql_db_name) == 0)
{
  $mysql_db_name = $default_mysql_db_name;
}


$default_mysql_table_name = "pocsag";

print "Desired MySQL table name [$default_mysql_table_name]: ";

chomp($mysql_table_name = <>);

if (length($mysql_table_name) == 0)
{
  $mysql_table_name = $default_mysql_table_name;
}


$default_mysql_uname = "pocsag";

print "It is recommended to create a restricted account for use with the decoder.\n";
print "Enter desired user name [$default_mysql_uname]: ";

chomp($mysql_uname = <>);

if (length($mysql_uname) == 0)
{
  $mysql_uname = $default_mysql_uname;
}



while ($mysql_upass eq '')
{
  print "Password for $mysql_uname: ";
  chomp($mysql_upass = <>);
}

#die "No password entered" if (length($mysql_upass) == 0);

$default_mysql_uhost = "localhost";

print "Allow connections from [$default_mysql_uhost]: ";
chomp($mysql_uhost = <>);

if (length($mysql_uhost) == 0)
{
  $mysql_uhost = $default_mysql_uhost;
}

$default_mysql_date                  = "y";
$default_mysql_ric                   = "y";
$default_mysql_bits                  = "y";
$default_mysql_msg                   = "y";
$default_mysql_msg_fixed             = "y";
$default_mysql_ric_uncorrected       = "y";
$default_mysql_msg_uncorrected       = "y";
$default_mysql_codeword_status       = "y";
$default_mysql_codewords             = "y";
$default_mysql_codewords_uncorrected = "y";
$default_mysql_errored               = "y";
$default_mysql_bitrate               = "y";
$default_mysql_channel               = "y";


print "\n";
print "Now we are going to select which columns we are going to include in the table structure\nPlease see the documentation for a description of these.\n";


print "date [$default_mysql_date]: ";
chomp($mysql_date = <>);

if (length($mysql_date) == 0)
{
  $mysql_date = $default_mysql_date;
}


print "ric [$default_mysql_ric]: ";
chomp($mysql_ric = <>);

if (length($mysql_ric) == 0)
{
  $mysql_ric = $default_mysql_ric;
}

print "bits [$default_mysql_bits]: ";
chomp($mysql_bits = <>);

if (length($mysql_bits) == 0)
{
  $mysql_bits = $default_mysql_bits;
}

print "msg [$default_mysql_msg]: ";
chomp($mysql_msg = <>);

if (length($mysql_msg) == 0)
{
  $mysql_msg = $default_mysql_msg;
}

print "msg_fixed [$default_mysql_msg_fixed]: ";
chomp($mysql_msg_fixed = <>);

if (length($mysql_msg_fixed) == 0)
{
  $mysql_msg_fixed = $default_mysql_msg_fixed;
}

print "ric_uncorrected [$default_mysql_ric_uncorrected]: ";
chomp($mysql_ric_uncorrected = <>);

if (length($mysql_ric_uncorrected) == 0)
{
  $mysql_ric_uncorrected = $default_mysql_ric_uncorrected;
}

print "msg_uncorrected [$default_mysql_msg_uncorrected]: ";
chomp($mysql_msg_uncorrected = <>);

if (length($mysql_msg_uncorrected) == 0)
{
  $mysql_msg_uncorrected = $default_mysql_msg_uncorrected;
}

print "codeword_status [$default_mysql_codeword_status]: ";
chomp($mysql_codeword_status = <>);

if (length($mysql_codeword_status) == 0)
{
  $mysql_codeword_status = $default_mysql_codeword_status;
}

print "codewords [$default_mysql_codewords]: ";
chomp($mysql_codewords = <>);

if (length($mysql_codewords) == 0)
{
  $mysql_codewords = $default_mysql_codewords;
}

print "codewords_uncorrected [$default_mysql_codewords_uncorrected]: ";
chomp($mysql_codewords_uncorrected = <>);

if (length($mysql_codewords_uncorrected) == 0)
{
  $mysql_codewords_uncorrected = $default_mysql_codewords_uncorrected;
}

print "errored [$default_mysql_errored]: ";
chomp($mysql_errored = <>);

if (length($mysql_errored) == 0)
{
  $mysql_errored = $default_mysql_errored;
}

print "bitrate [$default_mysql_bitrate]: ";
chomp($mysql_bitrate = <>);

if (length($mysql_bitrate) == 0)
{
  $mysql_bitrate = $default_mysql_bitrate;
}

print "channel [$default_mysql_channel]: ";
chomp($mysql_channel = <>);

if (length($mysql_channel) == 0)
{
  $mysql_channel = $default_mysql_channel;
}


$default_mysql_date                  = "y";
$default_mysql_ric                   = "y";
$default_mysql_bits                  = "y";
$default_mysql_msg                   = "y";
$default_mysql_msg_fixed             = "y";
$default_mysql_ric_uncorrected       = "y";
$default_mysql_msg_uncorrected       = "y";
$default_mysql_codeword_status       = "y";
$default_mysql_codewords             = "y";
$default_mysql_codewords_uncorrected = "y";
$default_mysql_errored               = "y";
$default_mysql_bitrate               = "y";
$default_mysql_channel               = "y";

print "\n";

push @mysql_input,"CREATE DATABASE IF NOT EXISTS $mysql_db_name;";
push @mysql_input,"USE $mysql_db_name;";
push @mysql_input,"DROP TABLE IF EXISTS \`$mysql_table_name\`;";
push @mysql_input,"CREATE TABLE \`$mysql_table_name\` (";
push @mysql_input,"`id` bigint(20) NOT NULL auto_increment,";


print "MySQL server: $mysql_server\n";
print "MySQL server port: $mysql_server_port\n";
print "MySQL server admin account: $mysql_admin\n";
print "MySQL database name: $mysql_db_name\n";
print "MySQL table name: $mysql_table_name\n\n";

print "The following columns will be used: ";

if ($mysql_date =~ m/^y/i)
{
  print "date ";
  push @mysql_config_h,"#define MYSQL_DATE";
  push @mysql_input,"`date` varchar(40) default NULL,";
}

if ($mysql_ric =~ m/^y/i)
{
  print "ric ";
  push @mysql_config_h,"#define MYSQL_RIC";
  push @mysql_input,"`ric` bigint(20) default NULL,";
}

if ($mysql_bits =~ m/^y/i)
{
  print "bits ";
  push @mysql_config_h,"#define MYSQL_BITS";
  push @mysql_input,"`bits` tinyint(4) default NULL,";
}

if ($mysql_msg =~ m/^y/i)
{
  print "msg ";
  push @mysql_config_h,"#define MYSQL_MSG";
  push @mysql_input,"`msg` varchar(1000) default NULL,";
}

if ($mysql_msg_fixed =~ m/^y/i)
{
  print "msg_fixed ";
  push @mysql_config_h,"#define MYSQL_MSG_FIXED";
  push @mysql_input,"`msg_fixed` varchar(1000) default NULL,";
}

if ($mysql_ric_uncorrected =~ m/^y/i)
{
  print "ric_uncorrected ";
  push @mysql_config_h,"#define MYSQL_RIC_UNCORRECTED";
  push @mysql_input,"`ric_uncorrected` bigint(20) default NULL,";
}

if ($mysql_msg_uncorrected =~ m/^y/i)
{
  print "msg_uncorrected ";
  push @mysql_config_h,"#define MYSQL_MSG_UNCORRECTED";
  push @mysql_input,"`msg_uncorrected` varchar(1000) default NULL,";
}

if ($mysql_codeword_status =~ m/^y/i)
{
  print "codeword_status ";
  push @mysql_config_h,"#define MYSQL_CODEWORD_STATUS";
  push @mysql_input,"`codeword_status` varchar(500) default NULL,";
}

if ($mysql_codewords =~ m/^y/i)
{
  print "codewords ";
  push @mysql_config_h,"#define MYSQL_CODEWORDS";
  push @mysql_input,"`codewords` blob,";
}

if ($mysql_codewords_uncorrected =~ m/^y/i)
{
  print "codewords_uncorrected ";
  push @mysql_config_h,"#define MYSQL_CODEWORDS_UNCORRECTED";
  push @mysql_input,"`codewords_uncorrected` blob,";
}

if ($mysql_errored =~ m/^y/i)
{
  print "errored ";
  push @mysql_config_h,"#define MYSQL_ERRORED";
  push @mysql_input,"`errored` tinyint(1) default NULL,";
}

if ($mysql_bitrate =~ m/^y/i)
{
  print "bitrate ";
  push @mysql_config_h,"#define MYSQL_BITRATE";
  push @mysql_input,"`bitrate` int(11) default NULL,";
}

if ($mysql_channel =~ m/^y/i)
{
  print "channel ";
  push @mysql_config_h,"#define MYSQL_CHANNEL";
  push @mysql_input,"`channel` int(11) default NULL,";
}

push @mysql_config_h,"\n";

print "\n";

push @mysql_input,"PRIMARY KEY  (`id`)";
push @mysql_input,") ENGINE=MyISAM AUTO_INCREMENT=0 DEFAULT CHARSET=latin1 ROW_FORMAT=DYNAMIC;";
push @mysql_input,"CREATE USER \'$mysql_uname\'@\'$mysql_uhost\' IDENTIFIED BY \'$mysql_upass\';";
push @mysql_input,"GRANT INSERT ON $mysql_db_name.$mysql_table_name TO \'$mysql_uname\'@\'$mysql_uhost\';\n";

open(FH,">mysql_config.h") or die "Couldn't create mysql_config.h";
print FH (join "\n",@mysql_config_h);
print "Wrote mysql_config.h\n\n";
close(FH);

open(FH,">mysql_input.txt");
print FH (join "\n",@mysql_input);
close(FH);

print "Restricted user account: $mysql_uname  Password: $mysql_upass\n\n";

print "I will now attempt to create the database $mysql_db_name, table $mysql_table_name and restricted account $mysql_uname\n";
print "on MySQL server at $mysql_server:$mysql_server_port\n\n";
print "If the table $mysql_table_name already exists, it will be deleted.\n\n";
print "Press enter to continue, or CTRL-C to exit.";

$a=<>;

push @mysql_input,"QUIT";

open (FH,">/tmp/msql.$$.in") or die "Couldn't create temporary file /tmp/msql.$$in";
print FH (join "\n",@mysql_input);
close(FH);

$cmdline = "mysql --protocol=tcp --host=$mysql_server --port=$mysql_server_port -u$mysql_admin -p$mysql_admin_pw < /tmp/msql.$$.in > /tmp/msql.$$.out 2>&1 \n";

open (FH,">/tmp/msql.$$.sh") or die "Couldn't open temporary file /tmp/msql.$$.sh";
print FH "#!/bin/sh\n";
print FH "$cmdline\n";
close(FH);
system("chmod","700","/tmp/msql.$$.sh");
system("/tmp/msql.$$.sh");
open (FH,"</tmp/msql.$$.out") or die "Couldn't open temporary file /tmp/msql.$$.out Possible reasons: MySQL not installed, or /tmp not writable.";
@mysql_output = <FH>;
close(FH);

if (scalar(@mysql_output) == 0)
{
  print "The operation appears to have been completed successfully.\n";
  print "To use, insert the following line in the configuration file (typically pocsag.conf) under the [mysql] section:\n";
  print "db=$mysql_db_name:$mysql_table_name:$mysql_uname:$mysql_upass:$mysql_server:$mysql_server_port\n";
} else
{
  print "Something may have gone wrong. The following message was returned from MySQL:\n";
  print join "\n",@mysql_output;
}

unlink("/tmp/msql.$$.sh");
unlink("/tmp/msql.$$.in");
unlink("/tmp/msql.$$.out");
