/*  The Ultimate POCSAG decoder v1.03d
 *
 *  Author: BHES <upocsag@s-lab.se>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#define CONFIG_NUMCHANNELS 2
#define CONFIG_SYNC 0x7CD215D8
#define CONFIG_ERROR_THRESHOLD 16
#define CONFIG_DSP_SAMPLE_RATE 48000
#define CONFIG_DSP_SAMPLE_BITS 16
#define CONFIG_DSP_INPUT_MODE stereo
#define CONFIG_DSP_INPUT_CHANNELS 2
#define CONFIG_DSP_DECODE_CHANNELS 2
#define CONFIG_DSP_LEFT_WEIGHT 1
#define CONFIG_DSP_RIGHT_WEIGHT 1
#define CONFIG_THRESHOLD 60
#define CONFIG_BITRATE_LIST 512,1200,2400
#define CONFIG_ALPHANUMERIC_BITS 3
#define CONFIG_NUMERIC_BITS 0,1,2
#define BATCHES 100
#define ZC_MEM_BLOCK_SIZE 500
#define CONFIG_IDLE 0x7A89C197
#define CONFIG_BATCH_LEN 544
#define CONFIG_LISTSIZE 18
#define CONFIG_MYSQL_COLUMNS 13
#define CONFIG_PCM_RAW_CHUNK_LENGTH_SECONDS 1000
#define CONFIG_PCM_RAW_CHUNK_SIZE CONFIG_PCM_RAW_CHUNK_LENGTH_SECONDS*CONFIG_DSP_SAMPLE_RATE*CONFIG_DSP_CHANNELS*(CONFIG_DSP_SAMPLE_BITS/8)/1000
#define CONFIG_AUDIO_MAX_QUEUE_SECONDS 10000
#define CONFIG_AUDIO_MAX_QUEUE_LENGTH CONFIG_AUDIO_MAX_QUEUE_SECONDS*CONFIG_DSP_SAMPLE_RATE*CONFIG_DSP_CHANNELS*(CONFIG_DSP_SAMPLE_BITS/8)/1000

#define DATE_FORMAT_LONG      "%Y-%m-%d %H:%M:%S"
#define DATE_FORMAT_SHORT     "%Y-%m-%d"
#define POCSAG_RAW_LOG_OK     "%Y-%m-%d.pocsag"
#define POCSAG_RAW_LOG_ERR    "%Y-%m-%d-error.pocsag"
#define LOGFILE_DATE_TEMPLATE "%Y-%m-%d.log"
#define DATE_FORMAT_DEBUG_FN  "%Y-%m-%d %H:%M:%S"
#define DEFAULT_CONFIG_FILE   "pocsag.conf"

char date_format_short[]      = {DATE_FORMAT_SHORT};
char date_format_long[]       = {DATE_FORMAT_LONG};
char pocsag_raw_log_ok[]      = {POCSAG_RAW_LOG_OK};
char pocsag_raw_log_err[    ] = {POCSAG_RAW_LOG_ERR};
char logfile_date_template[]  = {LOGFILE_DATE_TEMPLATE};
char date_format_debug_fn[]   = {DATE_FORMAT_DEBUG_FN};
char default_config_file_fn[] = {DEFAULT_CONFIG_FILE};

#define PCM_SERVER_LIMIT 20
#define PCM_SERVER_TIMEOUT 10

#define TELNET_SERVER_LIMIT 20
#define TELNET_SERVER_TIMEOUT 10

#define RAW_SERVER_LIMIT 20
#define RAW_SERVER_TIMEOUT 10

/* how many messages should we buffer if we can't access the mysql server ? */

#define MYSQL_MESSAGE_QUEUE_LIMIT 1000

/* console error highlighting */

#define ANSI_ESCAPE     0x1B,0x5B,0x00
#define ANSI_RED        "<<<ANSI_COLOR_PLACEHOLDER>>>1;31m"
#define ANSI_DARK_GREEN "<<<ANSI_COLOR_PLACEHOLDER>>>0;32m"
#define ANSI_GREEN      "<<<ANSI_COLOR_PLACEHOLDER>>>1;32m"
#define ANSI_YELLOW     "<<<ANSI_COLOR_PLACEHOLDER>>>1;33m"
#define ANSI_RESET      "<<<ANSI_COLOR_PLACEHOLDER>>>0m"
char ansi_escape[]                              = {ANSI_ESCAPE};
char console_eh_partially_corrected_prefix[]    = {ANSI_GREEN};
char console_eh_partially_corrected_suffix[]    = {ANSI_RESET};
char console_eh_partially_uncorrected_prefix[]  = {ANSI_YELLOW};
char console_eh_partially_uncorrected_suffix[]  = {ANSI_RESET};
char console_eh_fully_corrected_prefix[]        = {ANSI_DARK_GREEN};
char console_eh_fully_corrected_suffix[]        = {ANSI_RESET};
char console_eh_uncorrectable_prefix[]          = {ANSI_RED};
char console_eh_uncorrectable_suffix[]          = {ANSI_RESET};
char *console_eh[] = {console_eh_partially_corrected_prefix,
                      console_eh_partially_corrected_suffix,
                      console_eh_partially_uncorrected_prefix,
                      console_eh_partially_uncorrected_suffix,
                      console_eh_fully_corrected_prefix,
                      console_eh_fully_corrected_suffix,
                      console_eh_uncorrectable_prefix,
                      console_eh_uncorrectable_suffix};

/* IRC error highlighting */

#define IRC_COLOR      0x03,0x00
#define IRC_LIGHTGREEN "<<<COLOR_PLACEHOLDER>>>09"
#define IRC_YELLOW     "<<<COLOR_PLACEHOLDER>>>08"
#define IRC_DARKGREEN  "<<<COLOR_PLACEHOLDER>>>03"
#define IRC_RED        "<<<COLOR_PLACEHOLDER>>>04"
#define IRC_COLOR_SUFFIX "<<<COLOR_PLACEHOLDER>>>"
char irc_color[]                            = {IRC_COLOR};
char irc_eh_partially_corrected_prefix[]    = {IRC_LIGHTGREEN};
char irc_eh_partially_corrected_suffix[]    = {IRC_COLOR_SUFFIX};
char irc_eh_partially_uncorrected_prefix[]  = {IRC_YELLOW};
char irc_eh_partially_uncorrected_suffix[]  = {IRC_COLOR_SUFFIX};
char irc_eh_fully_corrected_prefix[]        = {IRC_DARKGREEN};
char irc_eh_fully_corrected_suffix[]        = {IRC_COLOR_SUFFIX};
char irc_eh_uncorrectable_prefix[]          = {IRC_RED};
char irc_eh_uncorrectable_suffix[]          = {IRC_COLOR_SUFFIX};
char *irc_eh[]     = {irc_eh_partially_corrected_prefix,
                      irc_eh_partially_corrected_suffix,
                      irc_eh_partially_uncorrected_prefix,
                      irc_eh_partially_uncorrected_suffix,
                      irc_eh_fully_corrected_prefix,
                      irc_eh_fully_corrected_suffix,
                      irc_eh_uncorrectable_prefix,
                      irc_eh_uncorrectable_suffix};




char *eh_str[]     = {"eh_partially_corrected_prefix",
                      "eh_partially_corrected_suffix",
                      "eh_partially_uncorrected_prefix",
                      "eh_partially_uncorrected_suffix",
                      "eh_fully_corrected_prefix",
                      "eh_fully_corrected_suffix",
                      "eh_uncorrectable_prefix",
                      "eh_uncorrectable_suffix"};




#define EH_TABLE_SIZE 6


char *eh_lookup[] = {"console",
                     "irc"};

char **eh_ptr[]    = {console_eh,
                     irc_eh};



enum eh_enum
{
  eh_partially_corrected_prefix,
  eh_partially_corrected_suffix,
  eh_partially_uncorrected_prefix,
  eh_partially_uncorrected_suffix,
  eh_fully_corrected_prefix,
  eh_fully_corrected_suffix,
  eh_uncorrectable_prefix,
  eh_uncorrectable_suffix,
  eh_enum_count
};


int32_t console_eh_size[] = {sizeof(console_eh_partially_corrected_prefix),
                        sizeof(console_eh_partially_corrected_suffix),
                        sizeof(console_eh_partially_uncorrected_prefix),
                        sizeof(console_eh_partially_uncorrected_suffix),
                        sizeof(console_eh_fully_corrected_prefix),
                        sizeof(console_eh_fully_corrected_suffix),
                        sizeof(console_eh_uncorrectable_prefix),
                        sizeof(console_eh_uncorrectable_suffix)};

int32_t config_bitrates[]          = {CONFIG_BITRATE_LIST};
int32_t config_alphanumeric_bits[] = {CONFIG_ALPHANUMERIC_BITS};
int32_t config_numeric_bits[]      = {CONFIG_NUMERIC_BITS};


int32_t *config_bitrates_num_alpha[]     = {config_bitrates,
                                        config_alphanumeric_bits,
                                        config_numeric_bits};

int32_t config_bitrates_num_alpha_size[] = {sizeof(config_bitrates)/sizeof(int32_t),
                                        sizeof(config_alphanumeric_bits)/sizeof(int32_t),
                                        sizeof(config_numeric_bits)/sizeof(int32_t)};


#define CONFIG_BITRATES sizeof(config_bitrate_list)/sizeof(int32_t)

char smbclient_cmd[] = "/usr/bin/smbclient";
char nmblookup_cmd[] = "/usr/bin/nmblookup";
char mta_cmd[]       = "/usr/sbin/sendmail";

char charset_file[] = "charset.tbl";

char program_string[] = "The Ultimate POCSAG decoder v1.03c (c) BHES";

struct pointer_queue
{
  void **ptr;
  uint32_t count;
};


struct message_block
{
  uint32_t ric;
  uint32_t ric_uncorrected;
  int32_t ric_status;
  uint32_t ric_cw;
  uint32_t ric_cw_uncorrected;
  uint32_t ric_cw_ecc_status;
  int32_t function_bits;
  int32_t ric_found;
  int32_t cw_len;
  uint32_t *codewords;
  uint32_t *codewords_uncorrected;
  uint32_t *idle_prefixed_codewords;
  uint32_t *idle_prefixed_codewords_uncorrected;
  uint32_t idle_prefixed_codewords_len;
  uint32_t idle_prefixed_codewords_uncorrected_len;
  uint32_t *codewords_ecc_status;
  uint32_t *codewords_ecc_flags;
  uint32_t unixtime;
  char *codewords_ecc_flags_str;
  uint32_t msg_len;
  unsigned char *msg;
  unsigned char *msg_fixed;
  unsigned char *msg_uncorrected;
  unsigned char *msg_fixed_no_crlf;
  char *date;
  int32_t ok;
  int32_t errored;
  int32_t bitrate;
  int32_t channel;
};

#ifdef USE_MYSQL

struct mysql_log
{
  char date,
       ric,
       bits,
       msg,
       msg_fixed_no_crlf,
       ric_uncorrected,
       msg_uncorrected,
       codeword_status,
       codewords,
       codewords_uncorrected,
       errored,
       bitrate,
       channel;
  char *hostname;
  int32_t port;
  char *db_name;
  char *db_table;
  char *username;
  char *password;
};

struct mysql_log *mysql_logging;

struct mysql_item
{
  int32_t length;
  char is_num;
  uint32_t num;
  char include;
  char discard;
  unsigned char *ptr;
  char *template;
} mysql_item;

struct mysql_row
{
  int32_t items;
  char connected;
  struct mysql_item **mysql_item_ptr;
};

struct mysql_item mysql_item_date,
                  mysql_item_ric,
                  mysql_item_bits,
                  mysql_item_msg,
                  mysql_item_msg_fixed_no_crlf,
                  mysql_item_ric_uncorrected,
                  mysql_item_msg_uncorrected,
                  mysql_item_codeword_status,
                  mysql_item_codewords,
                  mysql_item_codewords_uncorrected,
                  mysql_item_errored,
                  mysql_item_bitrate,
                  mysql_item_channel;

struct mysql_row *mysql_row_ptr_table;

char *mysql_template_strings[] = {"`date`='%s'",
                                  "`ric`='%s'",
                                  "`bits`='%s'",
                                  "`msg`='%s'",
                                  "`msg_fixed`='%s'",
                                  "`ric_uncorrected`='%s'",
                                  "`msg_uncorrected`='%s'",
                                  "`codeword_status`='%s'",
                                  "`codewords`='%s'",
                                  "`codewords_uncorrected`='%s'",
                                  "`errored`='%s'",
                                  "`bitrate`='%s'",
                                  "`channel`='%s'"};

char mysql_is_numeric[] = { 0,1,1,0,0,1,0,0,0,0,1,1,1 };

enum mysql_enum
{
  e_mysql_item_date,
  e_mysql_item_ric,
  e_mysql_item_bits,
  e_mysql_item_msg,
  e_mysql_item_msg_fixed_no_crlf,
  e_mysql_item_ric_uncorrected,
  e_mysql_item_msg_uncorrected,
  e_mysql_item_codeword_status,
  e_mysql_item_codewords,
  e_mysql_item_codewords_uncorrected,
  e_mysql_item_errored,
  e_mysql_item_bitrate,
  e_mysql_item_channel,
  e_mysql_enum_count
};

struct mysql_w
{
  struct mysql_item mysql_items[e_mysql_enum_count];
  struct mysql_row mysql_row_ptr_table;
  struct mysql_log_new *mysql_logging;
  MYSQL *mysql;
};


struct mysql_log_new
{
  char column[e_mysql_enum_count];
  char *hostname;
  int32_t port;
  char *db_name;
  char *db_table;
  char *username;
  char *password;
};

#endif

struct ric
{
  int32_t ch;
  int32_t ric;
  char *str;
};


struct str_list
{
  int32_t count;
  char **str;
};

struct ric_lookup
{
  int32_t count;
  struct ric **table;
};

struct ric_lookup *ric_lookup_table;

/*** Config data, category 1 ***/

enum config_wb_enum
{
  ric_whitelist,
  ric_blacklist,
  function_bits_whitelist,
  function_bits_blacklist,
  keyword_whitelist,
  keyword_blacklist,
  config_wb_enum_count
};



char config_wb_negate[] =
{
  0,
  1,
  0,
  1,
  0,
  1,
};

char *config_wb_fmt_strings_with_id[] =  {"ric-whitelist=%u=%s",
                                          "ric-blacklist=%u=%s",
                                          "function-bits-whitelist=%u=%s",
                                          "function-bits-blacklist=%u=%s",
                                          "keyword-whitelist=%u=%s",
                                          "keyword-blacklist=%u=%s"};

char *config_wb_fmt_strings_no_id[ ]   = {"ric-whitelist=%s",
                                          "ric-blacklist=%s",
                                          "function-bits-whitelist=%s",
                                          "function-bits-blacklist=%s",
                                          "keyword-whitelist=%s",
                                          "keyword-blacklist=%s"};

char *config_wb_strings[]              = {"ric-whitelist",
                                          "ric-blacklist",
                                          "function-bits-whitelist",
                                          "function-bits-blacklist",
                                          "keyword-whitelist",
                                          "keyword-blacklist"};


char *config_wb_fmt_strings_with_id_cmd[] =  {"--%[^,],ric-whitelist=%u=%s",
                                              "--%[^,],ric-blacklist=%u=%s",
                                              "--%[^,],function-bits-whitelist=%u=%s",
                                              "--%[^,],function-bits-blacklist=%u=%s",
                                              "--%[^,],keyword-whitelist=%u=%s",
                                              "--%[^,],keyword-blacklist=%u=%s"};

char *config_wb_fmt_strings_no_id_cmd[ ]   = {"--%[^,],ric-whitelist=%s",
                                              "--%[^,],ric-blacklist=%s",
                                              "--%[^,],function-bits-whitelist=%s",
                                              "--%[^,],function-bits-blacklist=%s",
                                              "--%[^,],keyword-whitelist=%s",
                                              "--%[^,],keyword-blacklist=%s"};

/*** Config data, category 2 ***/

enum config_int_enum
{
  dsp_sample_rate,
  dsp_sample_bits,
  dsp_left_weight,
  dsp_right_weight,
  dsp_max_queue_length,
  dsp_max_queue_length_bytes,
  dsp_input_channels,
  dsp_decode_channels,
  dsp_buffer_length,
  dsp_buffer_length_bytes,
  noise_smoothing_threshold,
  pcm_server_port,
  raw_server_port,
  raw_logging_error_threshold,
  config_int_enum_count
};

char *config_int_fmt_strings[]           = {"dsp-sample-rate=%u",
                                            "dsp-sample-bits=%u",
                                            "",
                                            "",
                                            "dsp-max-queue-length=%u",
                                            "",
                                            "dsp-input-channels=%u",
                                            "dsp-decode-channels=%u",
                                            "dsp-buffer-length=%u",
                                            "",
                                            "noise-smoothing-threshold=%u",
                                            "pcm-server-port=%u",
                                            "raw-server-port=%u",
                                            "raw-logging-error-threshold=%u"};



char *config_int_strings[] = {"dsp-sample-rate",
                              "dsp-sample-bits",
                              "dsp-left-weight",
                              "dsp-right-weight",
                              "dsp-max-queue-length",
                              "dsp-max-queue-length-bytes",
                              "dsp-input-channels",
                              "dsp-decode-channels",
                              "dsp-buffer-length",
                              "dsp-buffer-length-bytes",
                              "noise-smoothing-threshold",
                              "pcm-server-port",
                              "raw-server-port",
                              "raw-logging-error-threshold"};

char *config_int_fmt_strings_cmd[]           = {"--dsp-sample-rate=%u",
                                                "--dsp-sample-bits=%u",
                                               "",
                                               "",
                                               "--dsp-max-queue-length=%u",
                                               "",
                                               "--dsp-input-channels=%u",
                                               "--dsp-decode-channels=%u",
                                               "--dsp-buffer-length=%u",
                                               "",
                                               "--noise-smoothing-threshold=%u",
                                               "--pcm-server-port=%u",
                                               "--raw-server-port=%u",
                                               "--raw-logging-error-threshold=%u"};

/*** Config data, category 3 ***/

enum config_int_array_enum
{
  bitrates,
  alphanumeric_bits,
  numeric_bits,
  config_int_array_enum_count
};

char *config_int_array_fmt_strings[]     = {"bitrates=%s",
                                            "alphanumeric-bits=%s",
                                            "numeric-bits=%s"};

char *config_int_array_str[] = {"bitrates",
                                "alphanumeric-bits",
                                "numeric-bits"};


char *config_int_array_fmt_strings_cmd[]     = {"--bitrates=%s",
                                                "--alphanumeric-bits=%s",
                                                "--numeric-bits=%s"};

/*** Config data, category 4 ***/

enum config_str_enum
{
  input_source,
  input_mode,
  input_password,
  enabled,
  eh_enable,
  raw_logging,
  raw_logging_apply_ecc,
  noise_smoothing,
  dsp_input_mode,
  stats,
  stats_file,
  charset,
  smbclient,
  nmblookup,
  mta,
  from,
  pcm_server,
  raw_server,
  program_log,
  program_logfile,
  print_codewords,
  print_codewords_eh,
  pcm_server_password,
  raw_server_password,
  discard_errored_messages,
  config_str_enum_count
};




char *config_str_fmt_strings[] = {"input-source=%s",
                                  "input-mode=%s",
                                  "input-password=%s",
                                  "enabled=%s",
                                  "eh-enable=%s",
                                  "raw-logging=%s",
                                  "raw-logging-apply-ecc=%s",
                                  "noise-smoothing=%s",
                                  "dsp-input-mode=%s",
                                  "stats=%s",
                                  "stats-file=%s",
                                  "charset=%s",
                                  "smbclient=%s",
                                  "nmblookup=%s",
                                  "mta=%s",
                                  "from=%s",
                                  "pcm-server=%s",
                                  "raw-server=%s",
                                  "program-log=%s",
                                  "program-logfile=%s",
                                  "print-codewords=%s",
                                  "print-codewords-eh=%s",
                                  "pcm-server-password=%s",
                                  "raw-server-password=%s",
                                  "discard-errored-messages=%s"};



char *config_str_fmt_strings_cmd_main[] = {"--input-source=%s",
                                           "--input-mode=%s",
                                           "--input-password=%s",
                                           "--enabled=%s",
                                           "--eh-enable=%s",
                                           "--raw-logging=%s",
                                           "--raw-logging-apply-ecc=%s",
                                           "--noise-smoothing=%s",
                                           "--dsp-input-mode=%s",
                                           "--stats=%s",
                                           "--stats-file=%s",
                                           "--charset=%s",
                                           "--smbclient=%s",
                                           "--nmblookup=%s",
                                           "--mta=%s",
                                           "--from=%s",
                                           "--pcm-server=%s",
                                           "--raw-server=%s",
                                           "--program-log=%s",
                                           "--program-logfile=%s",
                                           "--print-codewords=%s",
                                           "--print-codewords-eh=%s",
                                           "--pcm-server-password=%s",
                                           "--raw-server-password=%s",
                                           "--discard-errored-messages=%s"};

char *config_str_fmt_strings_cmd[] =      {"--%[^,],input-source=%s",
                                           "--%[^,],input-mode=%s",
                                           "--%[^,],input-password=%s",
                                           "--%[^,],enabled=%s",
                                           "--%[^,],eh-enable=%s",
                                           "--%[^,],raw-logging=%s",
                                           "--%[^,],raw-logging-apply-ecc=%s",
                                           "--%[^,],noise-smoothing=%s",
                                           "--%[^,],dsp-input-mode=%s",
                                           "--%[^,],stats=%s",
                                           "--%[^,],stats-file=%s",
                                           "--%[^,],charset=%s",
                                           "--%[^,],smbclient=%s",
                                           "--%[^,],nmblookup=%s",
                                           "--%[^,],mta=%s",
                                           "--%[^,],from=%s",
                                           "--%[^,],pcm-server=%s",
                                           "--%[^,],raw-server=%s",
                                           "--%[^,],program-log=%s",
                                           "--%[^,],program-logfile=%s",
                                           "--%[^,],print-codewords=%s",
                                           "--%[^,],print-codewords-eh=%s",
                                           "--%[^,],pcm-server-password=%s",
                                           "--%[^,],raw-server-password=%s",
                                           "--%[^,],discard-errored-messages=%s"};

char *config_str_strings[] =     {"input-source",
                                  "input-mode",
                                  "input-password",
                                  "enabled",
                                  "eh-enable",
                                  "raw-logging",
                                  "raw-logging-apply-ecc",
                                  "noise-smoothing",
                                  "dsp-input-mode",
                                  "stats",
                                  "stats-file",
                                  "charset",
                                  "smbclient",
                                  "nmblookup",
                                  "mta",
                                  "from",
                                  "pcm-server",
                                  "raw-server",
                                  "program-log",
                                  "program-logfile",
                                  "print-codewords",
                                  "print-codewords-eh",
                                  "pcm-server-password",
                                  "raw-server-password",
                                  "discard-errored-messages"};

/* Which of the above options should we attempt to "translate" ? */
char config_str_lookup[] =
{
  0,
  1,
  0,
  1,
  1,
  1,
  1,
  1,
  1,
  1,
  0,
  0,
  0,
  0,
  0,
  0,
  1,
  1,
  1,
  0,
  1,
  1,
  0,
  0,
  1
};

enum config_str_keyword_enum
{
  allow,
  drop,
  left,
  right,
  stereo,
  no,
  yes,
  dsp_pcm,
  tcp_pcm,
  tcp_raw,
  file_raw,
  config_str_keyword_enum_count
};

char *config_str_keyword_strings[] = {"allow",
                                      "drop",
                                      "left",
                                      "right",
                                      "stereo",
                                      "no",
                                      "yes",
                                      "dsp-pcm",
                                      "tcp-pcm",
                                      "tcp-raw",
                                      "file-raw"};

/*** Config data, category 5 ***/

enum config_rcpt_str_enum
{
  to,
  db,
  host,
  recipient,
  logfile,
  l_port,
  external,
  config_rcpt_str_enum_count
};

char *config_rcpt_str_fmt_strings_with_id[] = {"to=%u=%s",
                                               "db=%u=%s",
                                               "host=%u=%s",
                                               "recipient=%u=%s",
                                               "logfile=%u=%s",
                                               "port=%u=%s",
                                               "external=%u=%s"};

char *config_rcpt_str_fmt_strings_no_id[] = {"to=%s",
                                             "db=%s",
                                             "host=%s",
                                             "recipient=%s",
                                             "logfile=%s",
                                             "port=%s",
                                             "external=%s"};

char *config_rcpt_str_fmt_strings_with_id_cmd[] = {"--%[^,],to=%u=%s",
                                                   "--%[^,],db=%u=%s",
                                                   "--%[^,],host=%u=%s",
                                                   "--%[^,],recipient=%u=%s",
                                                   "--%[^,],logfile=%u=%s",
                                                   "--%[^,],port=%u=%s",
                                                   "--%[^,],external=%u=%s"};

char *config_rcpt_str_fmt_strings_no_id_cmd[] = {"--%[^,],to=%s",
                                                 "--%[^,],db=%s",
                                                 "--%[^,],host=%s",
                                                 "--%[^,],recipient=%s",
                                                 "--%[^,],logfile=%s",
                                                 "--%[^,],port=%s",
                                                 "--%[^,],external=%s"};

char *config_rcpt_str[]                   = {"to",
                                             "db",
                                             "host",
                                             "recipient",
                                             "logfile",
                                             "port",
                                             "external"};
/*** Config data, category 6 ***/

enum config_mp_cs_enum
{
  message_policy,
  keyword_case_sensitive,
  config_mp_cs_enum_count
};

char *mp_cs_fmt_strings_with_id[] = {"message-policy=%u=%s",
                                     "keyword-case-sensitive=%u=%s"};

char *mp_cs_fmt_strings_no_id[] = {"message-policy=%s",
                                   "keyword-case-sensitive=%s"};

char *mp_cs_fmt_strings_with_id_cmd[] = {"--%[^,],message-policy=%u=%s",
                                         "--%[^,],keyword-case-sensitive=%u=%s"};

char *mp_cs_fmt_strings_no_id_cmd[]   = {"--%[^,],message-policy=%s",
                                         "--%[^,],keyword-case-sensitive=%s"};

char *mp_cs_strings[] = {"message-policy",
                         "keyword-case-sensitive"};

struct num_table
{
  int32_t *num_lookup;
  int32_t *num;
  int32_t num_count;
};


/*** Config data, category 7 ***/

enum config_error_highlight_enum
{
  e_partially_corrected_prefix,
  e_partially_corrected_suffix,
  e_partially_uncorrected_prefix,
  e_partially_uncorrected_suffix,
  e_fully_corrected_prefix,
  e_fully_corrected_suffix,
  e_uncorrectable_prefix,
  e_uncorrectable_suffix,
  config_error_highlight_enum_count
};

char *config_error_highlight_fmt_strings[] = {"eh-partially-corrected-prefix=%s",
                                              "eh-partially-corrected-suffix=%s",
                                              "eh-partially-uncorrected-prefix=%s",
                                              "eh-partially-uncorrected-suffix=%s",
                                              "eh-fully-corrected-prefix=%s",
                                              "eh-fully-corrected-suffix=%s",
                                              "eh-uncorrectable-prefix=%s",
                                              "eh-uncorrectable-suffix=%s"};

char *config_error_highlight_fmt_strings_cmd[] = {"--%[^,],eh-partially-corrected-prefix=%s",
                                                  "--%[^,],eh-partially-corrected-suffix=%s",
                                                  "--%[^,],eh-partially-uncorrected-prefix=%s",
                                                  "--%[^,],eh-partially-uncorrected-suffix=%s",
                                                  "--%[^,],eh-fully-corrected-prefix=%s",
                                                  "--%[^,],eh-fully-corrected-suffix=%s",
                                                  "--%[^,],eh-uncorrectable-prefix=%s",
                                                  "--%[^,],eh-uncorrectable-suffix=%s"};


char *config_error_highlight_strings[] = {"eh-partially-corrected-prefix",
                                          "eh-partially-corrected-suffix",
                                          "eh-partially-uncorrected-prefix",
                                          "eh-partially-uncorrected-suffix",
                                          "eh-fully-corrected-prefix",
                                          "eh-fully-corrected-suffix",
                                          "eh-uncorrectable-prefix",
                                          "eh-uncorrectable-suffix"};


/*** end ***/


enum recipients_int_enum
{
  _id = 0,
  _port,
  _precedence,
  is_parsed,
  connected,
  fd,
  _socket,
  ii,
  is_mysql,
  mysql_db_port,
  recipients_int_enum_count
};


char *config_rcpt_int_str[] =      {"id",
                                    "port",
                                    "precedence",
                                    "is_parsed",
                                    "connected",
                                    "fd",
                                    "socket",
                                    "ii",
                                    "is_mysql",
                                    "mysql_db_port"};

enum recipients_charptr_enum
{
  _logfile = 0,
  _ip_addr,
  _tmp,
  _tmps,
  _channel,
  mysql_db_name,
  mysql_db_table,
  mysql_db_username,
  mysql_db_password,
  mysql_db_hostname,
  recipients_char_ptr_enum_count
};


char *config_rcpt_char_str[] = {"logfile",
                                "ip_addr",
                                "tmp",
                                "tmps",
                                "channel",
                                "mysql_db_name",
                                "mysql_db_table",
                                "mysql_db_username",
                                "mysql_db_password",
                                "mysql_db_hostname"};


struct integer_list
{
  int32_t precedence;
  int32_t count;
  int32_t *list;
};


struct recipients
{
  char *str[recipients_char_ptr_enum_count];
  int32_t num[recipients_int_enum_count];
  struct str_list strlist; /* inlagd 090813 */
  struct mysql_w *msql;
  struct pointer_queue *queue;
  void **v;
  struct sockaddr_in srvr;
  struct timeval timeout;
  struct sigaction sv;
  struct hostent *ptr;
  FILE *io;
};


struct recipients_w
{
  int32_t count;
  struct recipients **rcpt;
};


struct whitelist_blacklist_item
{
  int32_t id;
  int32_t ch;
  int32_t kw;
  int32_t num;
  int32_t wb_type;
  char *keyword;
};

struct whitelist_blacklist
{
  int32_t count;
  int32_t default_policy;
  struct whitelist_blacklist_item **item;
};


struct whitelist_blacklist_wrap
{
 struct whitelist_blacklist **wb;
 int32_t enabled;
 int32_t *id_lookup;
 int32_t id_count;
};

struct log_functions_config
{
  int32_t enabled;
  struct recipients_w rec;
  struct whitelist_blacklist_wrap wb_wrap[config_wb_enum_count];
  int32_t num[config_int_enum_count];
  int32_t num_is_set[config_int_enum_count];
  struct integer_list *num_list[config_int_array_enum_count];
  char num_list_is_set[config_int_array_enum_count];
  char *str[config_str_enum_count];
  int32_t  str_num[config_str_enum_count];
  char str_num_is_set[config_str_enum_count];
  struct num_table ntab[config_mp_cs_enum_count];
  char *error_highlight[config_error_highlight_enum_count];
  struct ric_lookup *ric_strings;
  struct num_list **nl;
  int32_t    nl_count;
};


struct configuration_new
{
  int32_t count;
  int32_t *enabled;
  char **function_names;
  struct log_functions_config **log_config;
  void (**function)(struct message_block *, struct recipients *, struct log_functions_config *, struct ric_lookup *);
};


const int32_t fb_ascii[]            = {CONFIG_ALPHANUMERIC_BITS};
const int32_t fb_num[]              = {CONFIG_NUMERIC_BITS};

struct msg_str
{
  unsigned char *str;
  int32_t msglen;
  int32_t ok;
};

struct zc
{
  int32_t count;
  int32_t index;
  int32_t allocated;
  int32_t *zc_ptr;
};

const char num_charset[] =     {'0', '1', '2', '3',
                                '4', '5', '6', '7',
                                '8', '9', ' ', 'U',
                                ' ', '-', ']', '['};

struct pa
{
  int32_t sample;
  int32_t last_sample;
  int32_t last_crossing;
  int32_t list_last;
  int32_t sample_count;
  int32_t flag;
  int32_t cont;
};

struct pocraw
{
  uint32_t unixtime;
  uint32_t cw[16];
  uint32_t infoblock;
  uint32_t checksum;
};


struct pcm_raw_chunk
{
  uint32_t samplerate,bits,channels,length;
  unsigned char *ptr;
  struct integer_list *bitrate_list;
};

struct  pa_parameters
{
  int32_t init,sample_rate,bits,channels,length,num_chan;
  int32_t lw, rw;
  unsigned char *str;
  int32_t threshold;
  int32_t smoothing;
  int32_t highest_bitrate;
  struct integer_list **num_list;
};

struct tcp_struct
{
  char *host, *tmp, *tmps, *ip_addr;
  char *buf,*channel,*password;
  char *header_string;
  int32_t length,connected,port,socket,socket_w,fd,buflen,hdr_ok,init;
  int32_t samplerate,bits,channels;
  int32_t msg_connected;
  FILE *io_r;
  FILE *io_w;
  struct integer_list *bitrate_list;
  struct sockaddr_in srvr;
  struct timeval timeout;
  struct sigaction sv;
  struct hostent *ptr;
};


struct stats
{
  time_t first_run;
  time_t started;
  time_t last_updated;
  time_t time_running;
  uint32_t pcm_mbyte;
};

struct ch_br_stats
{
  uint32_t bitrate;
  uint32_t channel;
  uint32_t msg_alpha_ok;
  uint32_t msg_alpha_err;
  uint32_t msg_numeric_ok;
  uint32_t msg_numeric_err;
  uint32_t cw_ok;
  uint32_t cw_err;
};

struct poc_stats
{
  struct stats s;
  int32_t ch_br_count;
  struct ch_br_stats **ch_br;
};

struct num_list_items
{
  int32_t num;
  int32_t socket_dup;
  int32_t b;
  int32_t mb;
  int32_t tconn;
  int32_t socket;
  FILE *io_w,*io_r;
  struct in_addr sin_addr;
  uint16_t sin_port;
  char *str;
  char *header_string;
};

struct num_list
{
  struct num_list_items *items;
  int32_t count;
  int32_t id;
  int32_t port;
  int32_t msocket;
  char *password;
};

struct thread_slot
{
  pthread_t       thread;
  pthread_attr_t  thread_attr;
  pthread_mutex_t thread_mutex;
  FILE *io_r,*io_w;
  char *id_string;
  pthread_mutex_t *numlist_update_mutex;
  int32_t *connections;
  char *msg_connected;
  char *header_string;
  char *pw_temp;
  char *client_str;
  char *password;
  struct in_addr sin_addr;
  uint16_t sin_port;
  int32_t slot_no;
  int32_t started;
  int32_t socket,socket_dup;
  int32_t client_disconnected;
  int32_t inuse;
  int32_t client_port;
  int32_t samplerate,bits,channels;
  int32_t cleanup_sockets;
  struct num_list **nl;
  struct log_functions_config *lf;
};


struct mem_alloc_item
{
  long int address;
  time_t time;
  int32_t line_number;
  int32_t size;
  int32_t realloc;
  int32_t malloc;
};

struct mem_alloc_list
{
  int32_t count;
  struct mem_alloc_item **item;
};


struct server_parameters
{
  char *(*build_header_string)(struct pcm_raw_chunk *);
  char *id_string;
  char *password;
  char **header_string;
  int32_t server_limit;
  int32_t server_timeout;
  int32_t server_port;
  int32_t *connections;
  struct num_list **server_writable;
  struct num_list **server_readable;
  struct num_list **server_writable_new;
  struct num_list **server_readable_new;
  struct num_list **server_new_connections;
  pthread_mutex_t *server_mutex;
  pthread_mutex_t *server_mutex2;
  pthread_mutex_t *server_auth;
  pthread_cond_t  *server_cond;
  struct pointer_queue *queue;
};

struct raw_server_chunk
{
  int32_t channel;
  int32_t bitrate;
  int32_t decode_now;
  uint32_t unixtime;
  uint32_t codewords[16];
};

struct string_list
{
  int32_t count;
  char **str;
};


#define MSG_NOTICE  0x0
#define MSG_WARNING 0x1
#define MSG_ERROR   0x2

char *msg_type_prefix[] = {"",
                           "Warning",
                           "Error"};


struct configuration_new *config;

struct whitelist_blacklist *sak;

#define nmalloc(x)    n_malloc((x),__LINE__)
#define nrealloc(x,y) n_realloc((x),(y),__LINE__)
#define nfree(x)    n_free((x),__LINE__)


#define nenqueue(x,y)    n_enqueue((x),(y),__LINE__)
#define ndequeue(x,y,z)  n_dequeue((x),(y),(z),__LINE__)



void decode (int, int, int, int32_t *, struct integer_list **);
int32_t nearest(int,int);
void process_audio(void *);
void decode_batch(uint32_t *, int, int, int, struct integer_list **,uint32_t);
struct msg_str *pocsag_string_decode(uint32_t *, int32_t , int, struct integer_list **);
void ecc(uint32_t *,uint32_t *);
int32_t bch(uint32_t);
int32_t parity(uint32_t);
int32_t parity_ok(uint32_t);
void build_character_tables(char*);
unsigned char *translate(unsigned char *,int,char **);
int32_t func(int,int,int32_t *);
int checksum_ecc_ok(uint32_t *, int32_t);
void log_raw_data(char *, int32_t, int32_t, int32_t, uint32_t *, int32_t, uint32_t);
void endian_flip(uint32_t *);
int32_t round_up_nearest_multiple(int32_t, int32_t);
unsigned char *error_highlight_new(unsigned char *,uint32_t *,int32_t,int32_t,unsigned char **);
unsigned char *string_replace(unsigned char *, unsigned char *, unsigned char *);
void message_log(void);
void n_enqueue(struct pointer_queue *, void *,int32_t);
void *n_dequeue(struct pointer_queue *, int32_t *, void **,int32_t);
void register_log_function(struct configuration_new *, void *address, char *str);
int32_t get_log_function_index(struct configuration_new *, char *);
void config_parse(struct configuration_new *,int32_t,char **);
int32_t get_int_index(int32_t *, int32_t, int32_t, int32_t *, int32_t *);
struct whitelist_blacklist *parse_list(char *, struct whitelist_blacklist *, int32_t, int32_t);
struct integer_list *parse_int_csv(char *,struct integer_list *, int32_t);
struct recipients_w parse_rcpt_list_new(struct recipients_w *, char *,int32_t,int32_t);
void log_mysql(struct message_block *, struct recipients *, struct log_functions_config *, struct ric_lookup *);
void log_console(struct message_block *, struct recipients *, struct log_functions_config *, struct ric_lookup *);
void log_winmsg(struct message_block *, struct recipients *, struct log_functions_config *, struct ric_lookup *);
void log_irc(struct message_block *, struct recipients *, struct log_functions_config *, struct ric_lookup *);
void log_file(struct message_block *, struct recipients *, struct log_functions_config *, struct ric_lookup *);
void log_mail(struct message_block *, struct recipients *, struct log_functions_config *, struct ric_lookup *);
void log_telnet(struct message_block *, struct recipients *, struct log_functions_config *, struct ric_lookup *);
void log_external(struct message_block *, struct recipients *, struct log_functions_config *, struct ric_lookup *);
void char_replace(char *, char , char );
void str_tolower(char *str);
struct ric_lookup *parse_ric_lookup(struct ric_lookup *, char *);
char *ric_lookup_str(struct ric_lookup *, int, int32_t);
void int_sort(int32_t *, int32_t);
int32_t stricmp(char *, char *);
int32_t str_lookup(char *,char **,int );
void htonl_ptr(uint32_t *);
void ntohl_ptr(uint32_t *);
uint32_t bitmatch(uint32_t, char *);
char *parse_eh_string(char *);
void dump_config(struct configuration_new *);
void tcp_input(struct tcp_struct *,int32_t,int32_t (*)(char *, struct tcp_struct *));
char *pcm_build_header_string(struct pcm_raw_chunk *);
char *raw_build_header_string(struct pcm_raw_chunk *);
int32_t raw_header_string_match_parse(char *, struct tcp_struct *);
int32_t pcm_header_string_match_parse(char *, struct tcp_struct *);
struct num_list *int_add       (struct num_list *, int32_t, int32_t, struct in_addr *, uint16_t, int32_t,FILE *,FILE *, char *, char *);
struct num_list *int_remove_pos(struct num_list *, int32_t);
struct num_list *int_remove_num(struct num_list *, int32_t);
void   int_add_bytes           (struct num_list *, int32_t,int32_t);
int32_t    int_get_mb              (struct num_list *, int32_t);
char *gethostname_rr (char *);
char *gethostaddr_rr (struct in_addr *);
void stats_add(struct poc_stats *, uint32_t, uint32_t,
               uint32_t, uint32_t,
               uint32_t, uint32_t,
               uint32_t, uint32_t);
void stats_add_to_file(char *, struct poc_stats *);
void stats_load(char *, struct poc_stats *);
void stats_print(struct poc_stats *, struct poc_stats *);
char *sec2time(uint32_t);
int32_t len_diff(int32_t,int32_t);
int32_t stats_handler(void);
void telnet_listen(void *);
void telnet_auth(void *);
void telnet_cleanup(void *);
void server(void *);
void server_listen(void *);
void auth(void *);
void auth_cleanup(void *);
void dump_mem_list(struct mem_alloc_list *);
int32_t check_message(struct message_block *, struct recipients *, struct log_functions_config *);
int32_t wb_msg_match(struct message_block *, struct whitelist_blacklist_wrap *, struct log_functions_config *, int32_t, int32_t);
int32_t wb_id_index(struct whitelist_blacklist_wrap *, int32_t);
void *n_malloc(int32_t,int32_t);
void *n_realloc(void *,int32_t,int32_t);
void n_free(void *,int32_t);
int32_t pipe_handler(void);
int32_t got_alarm(void);
void print_log(int32_t,char *);
char *build_sha1_response_string(char *, char *);
void update_stats_structs(void);
struct string_list *glob_files(char *);
void message_log_cleanup(void*);



char raw_header[] = "POCSAGRAW";
uint32_t ***buffer;
uint32_t **bitcount;
struct message_block **decode_buffer;
struct msg_str *ret,*rv;
char **char_table, **char_table_no_crlf, **char_table_crlf_space, **char_table_mysql_escape;
char *ptr;
struct pa_parameters *pa_param;
uint32_t *cw_temp;
struct pcm_raw_chunk *raw_server_chunk,*pcm_server_chunk,*audio;
struct pointer_queue    *audio_queue;
struct pointer_queue    *log_queue;
struct pointer_queue    *pcm_server_audio_queue;
struct pointer_queue    *raw_server_queue;

pthread_t       audio_thread,log_thread, pcm_server_thread, pcm_server_listen_thread,telnet_server_thread,raw_server_thread,raw_server_listen_thread;
pthread_attr_t  audio_attr,log_attr,  pcm_server_attr, pcm_server_listen_attr,telnet_server_attr,raw_server_attr,raw_server_listen_attr;
pthread_mutex_t audio_mutex,log_mutex,stats_mutex, pcm_server_mutex, pcm_server_mutex2, raw_server_mutex, raw_server_mutex2, telnet_server_mutex,memory_mutex, memory_mutex2, print_log_mutex, pcm_server_auth, raw_server_auth, int_add_remove, time_mutex, exit_mutex;
pthread_cond_t  audio_cond,log_cond,stats_cond, pcm_server_cond, raw_server_cond, telnet_server_cond,memory_cond, memory_cond2, print_log_cond, exit_cond;


struct mem_alloc_list list;
struct raw_server_chunk *raw_chunk;
sigjmp_buf alarmret;
sigjmp_buf alarmret_stats;
struct poc_stats s_stats, t_stats;
char *statsfile;
int32_t main_config_index;
int32_t to_exit = 0;
int32_t telnet_connections = 0;
int32_t pcm_connections = 0;
int32_t raw_connections = 0;
int32_t pcm_server_samplerate,pcm_server_channels,pcm_server_bits;
int32_t pcm_server_sample_info_received = 0;
int32_t exit_now = 0;
int32_t use_exit_flag = 0;
int32_t conf_ok = 0;
struct num_list *pcm_server_writable,*pcm_server_writable_new,*pcm_server_readable,*pcm_server_readable_new;
struct num_list *pcm_server_new_connections;
struct num_list *raw_server_writable,*raw_server_writable_new,*raw_server_readable,*raw_server_readable_new;
struct num_list *raw_server_new_connections;
struct server_parameters pcm_server_parameters;
struct server_parameters raw_server_parameters;
char *pcm_server_header_string;
char *raw_server_header_string;
